package com.loafle.overflow.model.meta;

import com.loafle.overflow.model.meta.MetaInfraType;
import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_TARGET_TYPE", schema = "public")
@Inheritance(strategy = InheritanceType.JOINED)
@DiscriminatorColumn(name = "META_INFRA_TYPE_ID", discriminatorType = DiscriminatorType.INTEGER)
public abstract class MetaTargetType {
  private Integer id;
  private MetaInfraType metaInfraType;
  private String key;
  private String name;
  private Boolean isSupported;
  private Date createDate;

  @Id
  public Integer getId() {
    return id;
  }

  public void setId(Integer id) {
    this.id = id;
  }

  @ManyToOne
  @JoinColumn(name = "META_INFRA_TYPE_ID", nullable = false)
  public MetaInfraType getMetaInfraType() {
    return metaInfraType;
  }

  public void setMetaInfraType(MetaInfraType metaInfraType) {
    this.metaInfraType = metaInfraType;
  }

  @Column(name = "KEY", nullable = true, length = 50)
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  @Column(name = "NAME", nullable = true, length = 50)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @Basic
  @Column(name = "IS_SUPPORTED", nullable = false, columnDefinition = "Boolean default false")
  public Boolean getSupported() {
    return isSupported;
  }

  public void setSupported(Boolean isSupported) {
    this.isSupported = isSupported;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }
}
