package com.loafle.overflow.service.central.sensor;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.sensor.SensorItem;
import org.springframework.data.domain.Page;

import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface SensorService {
  @WebappAPI
  Sensor regist(Sensor sensor, Long targetID) throws OverflowException;

  @WebappAPI
  Sensor read(Long id) throws OverflowException;

  @WebappAPI
  void remove(Long id, Long targetID) throws OverflowException;

  @WebappAPI
  Page<Sensor> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException;

  @WebappAPI
  Page<Sensor> readAllByDomainID(Long domainID, PageParams pageParams) throws OverflowException;

  @WebappAPI
  Page<Sensor> readAllByInfraID(Long infraID, PageParams pageParams) throws OverflowException;

  @WebappAPI
  Page<Sensor> readAllByTargetID(Long targetID, PageParams pageParams) throws OverflowException;

  Sensor increaseSensorItemCount(Long id) throws OverflowException;
  
  Sensor decreaseSensorItemCount(Long id) throws OverflowException;


  @WebappAPI
  Sensor registSensorConfig(Sensor sensor, List<SensorItem> sensorItemList, String etcJson) throws OverflowException;

  @WebappAPI
  String generateSensorConfig(Sensor sensor) throws OverflowException;

}
